/*********************************/
/*	COMP 250	
 * 	Assigment 3
 * 
 * 	By: 
 * 	Simon Foucher
 * 	260 223 197
 * 
/*********************************/

package Question3;


/*	
 * you will be graded on the style and comments in your code 
 * as well as the correctness of your solution
 */




public class Sunsets{


	// Basic function to compute power
	public static int power(int x, int n){
		if(n == 0)
			return 1;
		else{
			int tmp = power(x, n/2);
			if(n%2 == 1)
				return tmp*tmp*x;
			else
				return tmp*tmp; 
		}
	}
	

	
	
	// Main function to count sunsets
	
	public static int countSunsets(int[] altitudes){
		
		int i;										// General counter
		int n;										// Total number of camp sites
		int threshold;								// Threshold of the number past peeks that can potentially block out view
		int sunsets;								// Sunset counter
		Qstack Q = new Qstack();					// Blend of Q and stack (see Qstack.java for description)
		int Temp = 0;								

		
		// First compute threshold of past events to evaluate (takes n time)
		n = altitudes.length;						// Make division
		threshold = n/5;
		if(n%5 > 0)									// Account for ceiling
			threshold++;
		

		sunsets = 0;

		
		

		//  Run the following test for every camps\
		for(i = 1; i < n; i++){

			
			// Look at previous elements that might block our view 
			// Q.size is at most threshold = n/5 (see below in the code)
			while(Q.sizeIs() > 0){
				Temp = Q.peek();									// Peek was modified to show the stack end of the Q

				// If our altitude is smaller than last guy on stack
				// We don't see a sunset so break out of loop
				if(altitudes[i] < Temp){	
					break;
				}
				
				// Otherwise, compare with every elements until the Q is empty (meaning we see a sunset)
				if(altitudes[i] >=  Temp){							// If our altitude greater than last guy on stack		
					Q.deStack();									// Get rid of him because he doesn't matter anymore
				}													// New element will be shading his sunset
			}
	
			// If we reached the end of the Q (means no one is bigger than this camp)
			if(Q.sizeIs() == 0)
				sunsets++;
			
			// Either way, add this guy to the top of the stack
			Q.enqueue(altitudes[i]);
			
			// Keep track of only threshold eyesight long
			// When reached n/5, get rid of farthest point (a regular LIFO withdraw from the Q)
			if(Q.sizeIs() > threshold)
				Q.dequeue();
		}

		// That's it
		return sunsets;			
	}
	
	
	
	
	public static void main(String[] args){
		int mapFromNASA[] = {4, 1, 2, 6, 9, 3, 12, 3, 2, 5, 9, 10, 8};		//	sample test case
		System.out.println("The number of sunsets seen = " + countSunsets(mapFromNASA));
	}
	
	/*
	 * WRITE WHY YOUR ALGORITHM RUNS IN O(n) HERE
	 * 
	 * 
	 * During initialization, we count n (takes n time) then we do a few operations
	 * Which gets us to n + k when the main While loop starts.
	 * 
	 * Throughout the iterations, every element will be entered a single time on the stackQ, and may  
	 * be only removed from it a single time, which gives us 2n time complexity worst case.
	 * 
	 * Then a bit of overhead
	 * 
	 * 
	 * Adding everything up together, we get t(n) = an + k
	 * So the algorithm runs on O(n) time
	 */
}